package com.ruoyi.frequency.sale.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.page.PageResult;
import com.ruoyi.controller.req.RegisterUserReq;
import com.ruoyi.controller.req.SaleDetailPageReq;
import com.ruoyi.controller.req.UserEditReqVo;
import com.ruoyi.controller.resp.RankingResp;
import com.ruoyi.controller.resp.SaleDetailPageResp;
import com.ruoyi.frequency.sale.entity.Sale;
import com.ruoyi.frequency.sale.model.result.SaleCount;
import com.ruoyi.response.ResponseData;
import com.ruoyi.vo.PageBasic;
import com.ruoyi.vo.UserVo;

import java.util.List;

/**
 * 销售账号Service接口
 *
 * @author zj
 * @date 2023-09-22
 */
public interface SaleService extends IService<Sale>
{
    /**
     * 查询销售账号
     *
     * @param id 销售账号主键
     * @return 销售账号
     */
    public Sale selectSaleById(Long id);

    /**
     * 查询销售账号列表
     *
     * @param sale 销售账号
     * @return 销售账号集合
     */
    public List<Sale> selectSaleList(Sale sale);

    SaleCount statistics(Sale sale);

    /**
     * 新增销售账号
     *
     * @param sale 销售账号
     * @return 结果
     */
    public int insertSale(Sale sale);

    /**
     * 修改销售账号
     *
     * @param sale 销售账号
     * @return 结果
     */
    public int updateSale(Sale sale);

    /**
     * 批量删除销售账号
     *
     * @param ids 需要删除的销售账号主键集合
     * @return 结果
     */
    public int deleteSaleByIds(Long[] ids,Integer delFlag);

    /**
     * 删除销售账号信息
     *
     * @param id 销售账号主键
     * @return 结果
     */
    public int deleteSaleById(Long id);

    /**
     * 修改余额
     * @param sale
     * @return
     */
    AjaxResult updateBalance(Sale sale);

    /**
     * 编辑用户信息
     * @param req
     * @param userVo
     * @return
     */
    ResponseData editInfo(UserEditReqVo req, UserVo userVo);

    /**
     * 用户个人信息
     * @param userVo
     * @return
     */
    ResponseData info(UserVo userVo);

    Sale assembleSale(RegisterUserReq req, String md5Pwd);

    /**
     * 佣金排名
     * @param userVo
     * @return
     */
    Integer commissionRanking(UserVo userVo);


    /**
     * 推广排名
     * @param userVo
     * @return
     */
    Integer saleRanking(UserVo userVo);

    /**
     * 佣金排名列表
     * @param userVo
     * @return
     */
    ResponseData<PageResult<Page<RankingResp>>> commissionRankingPage(PageBasic req,UserVo userVo);


    /**
     *  推广排名列表
     * @param userVo
     * @return
     */
    ResponseData<PageResult<Page<RankingResp>>> saleRankingPage(PageBasic req,UserVo userVo);

    /**
     * 明细
     * @param req
     * @param userVo
     * @return
     */
    ResponseData<PageResult<Page<SaleDetailPageResp>>> saleDetailPage(SaleDetailPageReq req, UserVo userVo);

}
